<?php

// CONFIGURATION

define('CFG_MAKE_MAIL_ADDRESSES_CLICKABLE', true);
define('CFG_CORRET_MISSING_MAILTO', true);

// CODE

function secure_email_triv($email)
{
	if (!function_exists('alas_js_crypt'))
	{
		function alas_js_crypt($text)
		{
			$tmp = '';
			for ($i=0; $i<strlen($text); $i++)
			{
				$tmp .= 'document.write("&#'.ord(substr($text, $i, 1)).';");';
			}
			return $tmp;
		}
	}

	$aus = '';
	if ($email != '')
	{
		$aus .= '<script language="JavaScript" type="text/javascript"><!--'."\n";
		$aus .= alas_js_crypt($email);
		$aus .= '// --></script>';
	}
	return $aus;
}

function getAddrSpec() {
	// Ref: http://www.iamcal.com/publish/articles/php/parsing_email/

	$qtext = '[^\\x0d\\x22\\x5c\\x80-\\xff]';
	$dtext = '[^\\x0d\\x5b-\\x5d\\x80-\\xff]';
	$atom = '[^\\x00-\\x20\\x22\\x28\\x29\\x2c\\x2e\\x3a-\\x3c\\x3e\\x40\\x5b-\\x5d\\x7f-\\xff]+';
	$quoted_pair = '\\x5c[\\x00-\\x7f]';
	$domain_literal = "\\x5b($dtext|$quoted_pair)*\\x5d";
	$quoted_string = "\\x22($qtext|$quoted_pair)*\\x22";
	$domain_ref = $atom;
	$sub_domain = "($domain_ref|$domain_literal)";
	$word = "($atom|$quoted_string)";
	$domain = "$sub_domain(\\x2e$sub_domain)*";
	$local_part = "$word(\\x2e$word)*";
	$addr_spec = "$local_part\\x40$domain";

	return $addr_spec;
}

function is_valid_email_address($email) {
	// TODO: Hier lieber einen korrekten Mailvalidator verwenden (C.Sayers Lsung)?

	$ary = explode('?', $email);
	$email = $ary[0];

	$addr_spec = getAddrSpec();
	return preg_match("!^$addr_spec$!", $email);
}

class MailLinkProtector extends UrlParseIterator {
	var $correct_missing_mailto;

	protected function link_callback($complete, $pre, $post, $urltype, $bracket, $url, $linktext) {
		if (beginsWithI($url, 'mailto:')) {
			// Link ist eine Mailadresse
			$mailaddr = remove_beginning_i($url, 'mailto:');
			return secure_email($mailaddr, $linktext, is_valid_email_address($linktext));
		} else if (($this->correct_missing_mailto) && (is_valid_email_address($url))) {
			// Hier hat jemand "mailto:" vergessen. Wir korrigieren das mal...
			$mailaddr = $url;
			return secure_email($mailaddr, $linktext, is_valid_email_address($linktext));
		} else {
			// Normaler Link
			return $complete;
		}
	}
}

function link_cb_2($a) {
	$mailaddr = $a[1]; // Letztes

	if (CFG_MAKE_MAIL_ADDRESSES_CLICKABLE) {
		return secure_email($mailaddr, $mailaddr, true);
	} else {
		return secure_email_triv($mailaddr);
	}
}

function protect_mail_address_urls($content, $correct_missing_mailto = true) {
	$t = new MailLinkProtector;
	$t->correct_missing_mailto = $correct_missing_mailto;
	return $t->process($content);
}

function auto_secure_mail_addresses($content) {
	// Step 1: Parse links and make them secure

	$content = protect_mail_address_urls($content, CFG_CORRET_MISSING_MAILTO);

	// Step 2: Find all further mail addresses, make then clickable and prevent spam bots

	$addr_spec = getAddrSpec();

	// This fixes an error if the file is unix converted...
	// The error occoured at server4.configcenter.info:
	// [Fri Mar 26 20:23:24 2010] [error] [client 87.165.172.145] (104)Connection reset by peer: FastCGI: comm with server "/home/www/web66/html/cgi-bin/php-fcgi-starter" aborted: read failed
	// [Fri Mar 26 20:23:24 2010] [error] [client 87.165.172.145] FastCGI: incomplete headers (0 bytes) received from server "/home/www/web66/html/cgi-bin/php-fcgi-starter"
	$content = str_replace("\n", "\r\n", $content);

	$content = preg_replace_callback("@($addr_spec)@sm", 'link_cb_2', $content);

	// Output

	return $content;
}

$content = auto_secure_mail_addresses($content);

?>
