<?php

/*

+==============================================================================================================+
|                                                                                                              |
|  ##     ##    ###    ########  ##     ##    ######## ##    ##  ######   #### ##    ## ########     #######   |
|  ###   ###   ## ##   ##     ##  ##   ##     ##       ###   ## ##    ##   ##  ###   ## ##          ##     ##  |
|  #### ####  ##   ##  ##     ##   ## ##      ##       ####  ## ##         ##  ####  ## ##                 ##  |
|  ## ### ## ##     ## ########     ###       ######   ## ## ## ##   ####  ##  ## ## ## ######       #######   |
|  ##     ## ######### ##   ##     ## ##      ##       ##  #### ##    ##   ##  ##  #### ##          ##         |
|  ##     ## ##     ## ##    ##   ##   ##     ##       ##   ### ##    ##   ##  ##   ### ##          ##         |
|  ##     ## ##     ## ##     ## ##     ##    ######## ##    ##  ######   #### ##    ## ########    #########  |
|                                                                                                              |
+==============================================================================================================+
                                                                  ASCII Art by http://patorjk.com/software/taag/

MarxEngine 2.0.7 by Daniel Marschall
(C)Copyright 2009 - 2010 ViaThinkSoft

*/

require('config.inc.php');

define('MARX_ENGINE_VER', '2.0.7 (2010-09-28)');
define('INDEX_NAME', 'index');
define('DEFAULT_NAME', 'default');
define('INC_PHP', '.inc.php');
define('SITEMAP_URL', 'sitemap.txt');

define('NOTFOUND_NAME', '#error_notfound');
define('AUTO_INCLUDE_DIR', './#autoincludes/');
define('FILTER_DIR', './#filters/');
define('DESIGN_PREFIX', '#design_');
define('METATAGS_PREFIX', '#metatags_');
define('INTERRUPT_PREFIX', '#interrupt_');
define('MENU_PREFIX', '#menu_');

// Fix IE/GoogleChrome issue: Individual error pages have to be long
define('IE_ERRORPAGE_FIX', '<!--'.str_repeat(' ', 3000).'-->');

// *** THE CODE BEGINS HERE ***

define('MARX_ENGINE_USED', true);

if (CFG_STRICT_ERROR_REPORTING) {
	error_reporting(E_ALL | E_NOTICE);
}
header('X-Powered-By: ViaThinkSoft MarxEngine '.MARX_ENGINE_VER);

// Check if everything is OK.

if (beginsWith($_SERVER['REQUEST_URI'], $_SERVER['SCRIPT_NAME'])) {
	header($_SERVER['SERVER_PROTOCOL'].' 403 Forbidden');
	echo '<h1>Forbidden</h1>';
	echo '<p>Cannot call engine directly.</p>';
	echo simple_html_foot();
	die();
}

// Aquire information

$reqfile = $_SERVER['REQUEST_URI'];

if (($quepos = strpos($reqfile, '?')) !== false) {
	// GET-Parameter entfernen (sie wurden durch PHP bereits interpretiert)
	$reqfile = substr($reqfile, 0, $quepos);
}
unset($quepos);

$reqfile = remove_beginning($reqfile, dir_add_trailing_slash(dirname($_SERVER['SCRIPT_NAME'])));
if ($reqfile === false) $reqfile = '';
$reqfile = './'.$reqfile;

// Hacker safeness

$reqfile = str_replace('../', '', $reqfile);
$reqfile = str_replace('..\\', '', $reqfile);

// Tests

if ((!is_allowed_file($reqfile)) || (!is_no_errorpage($reqfile))) {
	header($_SERVER['SERVER_PROTOCOL'].' 403 Forbidden');
	echo '<h1>Forbidden</h1>';
	echo '<p>This file is used internally and cannot be accessed directly.</p>';
	echo simple_html_foot();
	die();
}

// Includes for the content

$incl_ary = glob(dir_add_trailing_slash(AUTO_INCLUDE_DIR).'*'.INC_PHP);

if ((is_array($incl_ary)) && (count($incl_ary) > 0)) {
	foreach ($incl_ary as $val) {
		include $val;
	}
	unset($val);
}

unset($incl_ary);

$directory = dirname($reqfile);
$directory = dir_add_trailing_slash($directory);

if ((is_dir($reqfile)) && (!file_exists(dir_add_trailing_slash($reqfile).INDEX_NAME.CFG_EXTENSION))) {
	/* DIRECTORY LISTING CONTROLLER

	 ######                                                         #                                             #####
	 #     # # #####  ######  ####  #####  ####  #####  #   #       #       #  ####  ##### # #    #  ####        #     #  ####  #    # ##### #####   ####  #      #      ###### #####
	 #     # # #    # #      #    #   #   #    # #    #  # #        #       # #        #   # ##   # #    #       #       #    # ##   #   #   #    # #    # #      #      #      #    #
	 #     # # #    # #####  #        #   #    # #    #   #   ##### #       #  ####    #   # # #  # #      ##### #       #    # # #  #   #   #    # #    # #      #      #####  #    #
	 #     # # #####  #      #        #   #    # #####    #         #       #      #   #   # #  # # #  ###       #       #    # #  # #   #   #####  #    # #      #      #      #####
	 #     # # #   #  #      #    #   #   #    # #   #    #         #       # #    #   #   # #   ## #    #       #     # #    # #   ##   #   #   #  #    # #      #      #      #   #
	 ######  # #    # ######  ####    #    ####  #    #   #         ####### #  ####    #   # #    #  ####         #####   ####  #    #   #   #    #  ####  ###### ###### ###### #    #

	*/

	if (CFG_ALLOW_DIRECTORY_LISTING) {
		$TITLE = 'Directory listing: '.$reqfile;
		echo simple_html_head($TITLE);
		echo '<h1>'.$TITLE.'</h1>';
		unset($TITLE);

		$files = getAllFilesAndDirsNonRec(dir_add_trailing_slash($reqfile));
		asort($files);

		if ((is_array($files)) && (count($files) > 0)) {
			foreach ($files as $file) {
				// Do not show "../" if listing in the domain rootpath
				if (($file == './../') && (ownSystemRelURI() == '')) continue;

				// Do not show ".*" files
				if (($file != './../') && (beginsWith($file, './.'))) continue;

				// Do not show internally used files
				if ((!is_allowed_file($file)) || (!is_no_errorpage($file))) continue;

				$filename = substr($file, strlen(dir_add_trailing_slash($reqfile)), strlen($file)-strlen(dir_add_trailing_slash($reqfile)));

				if (endsWith($filename, '/')) {
					$a_filename = urlencode(substr($filename, 0, strlen($filename)-1)).'/';
				} else {
					$a_filename = urlencode($filename);
				}
				echo "<a href=\"$a_filename\">$filename</a><br>";
				unset($a_filename);
			}
			unset($filename);
			unset($file);
		}
		unset($files);
	} else {
		header($_SERVER['SERVER_PROTOCOL'].' 403 Forbidden');

		$TITLE = 'Forbidden';
		echo simple_html_head($TITLE);
		echo '<h1>'.$TITLE.'</h1>';
		unset($TITLE);

		echo '<p>Sorry, directory listing is disabled.</p>';
	}

	echo '<br><hr>';
	echo '<p><i>Powered by MarxEngine '.MARX_ENGINE_VER.'</i></p>';

	echo simple_html_foot();
	die();
} else if ((basename($reqfile) == SITEMAP_URL) && (is_dir($directory))) {
	/* SITEMAP CONTROLLER

	  #####                                             #####
	 #     # # ##### ###### #    #   ##   #####        #     #  ####  #    # ##### #####   ####  #      #      ###### #####
	 #       #   #   #      ##  ##  #  #  #    #       #       #    # ##   #   #   #    # #    # #      #      #      #    #
	  #####  #   #   #####  # ## # #    # #    # ##### #       #    # # #  #   #   #    # #    # #      #      #####  #    #
	       # #   #   #      #    # ###### #####        #       #    # #  # #   #   #####  #    # #      #      #      #####
	 #     # #   #   #      #    # #    # #            #     # #    # #   ##   #   #   #  #    # #      #      #      #   #
	  #####  #   #   ###### #    # #    # #             #####   ####  #    #   #   #    #  ####  ###### ###### ###### #    #

	*/

	if (CFG_UTF8_SITEMAP) {
		header('Content-type: text/plain; charset=utf-8');
	} else {
		header('Content-type: text/plain; charset=iso-8859-1');
	}

	$files = getAllHtmlFiles(dir_add_trailing_slash($directory));
	$files = array_filter($files, 'is_allowed_file');
	$files = array_filter($files, 'is_no_errorpage');
	asort($files);

	if ((is_array($files)) && (count($files) > 0)) {
		foreach ($files as $file) {
			$filename = substr($file, strlen(dir_add_trailing_slash($directory)), strlen($file)-strlen(dir_add_trailing_slash($directory)));
			$RELDIR = remove_beginning($directory, './');
			$odi = ownDirectoryURI($RELDIR);
			$uri = $odi.$filename;

			$ary = explode('/', $uri);
			$private = false;
			foreach ($ary as $val) {
				if (beginsWith($val, '_')) $private = true;
			}
			unset($val);
			unset($ary);
			if ($private) {
				unset($private);
				continue;
			}

			if (CFG_UTF8_SITEMAP) {
				echo utf8_encode($uri);
			} else {
				echo $uri;
			}
			unset($odi);
			unset($uri);
			echo "\r\n";
		}
		unset($filename);
		unset($file);
	}
	unset($files);
} else {
	/* PAGE CONTROLLER

	 ######                              #####
	 #     #   ##    ####  ######       #     #  ####  #    # ##### #####   ####  #      #      ###### #####
	 #     #  #  #  #    # #            #       #    # ##   #   #   #    # #    # #      #      #      #    #
	 ######  #    # #      #####  ##### #       #    # # #  #   #   #    # #    # #      #      #####  #    #
	 #       ###### #  ### #            #       #    # #  # #   #   #####  #    # #      #      #      #####
	 #       #    # #    # #            #     # #    # #   ##   #   #   #  #    # #      #      #      #   #
	 #       #    #  ####  ######        #####   ####  #    #   #   #    #  ####  ###### ###### ###### #    #

	*/

	$content_file = $reqfile;

	// For directories we try to call the "index.html"
	if (is_dir($content_file)) {
		// Wrde die index.html ein Redirect machen und die angeforderte URL kein "/" am Ende besitzen,
		// so wrde sich wieder Weiterleitung auf das bergeordnete Verzeichns beziehen!
		if (!endsWith($content_file, '/')) {
			redirect($reqfile.'/');
		}

		$content_file = dir_add_trailing_slash($content_file).INDEX_NAME.CFG_EXTENSION;
	}

	$directory = dirname($content_file); // renew variable
	$directory = dir_add_trailing_slash($directory);

	// Initialiere magische Variablen

	$RELDIR = remove_beginning($directory, './');

	// Fr magic constants in Metatags
	if ($RELDIR === false) $RELDIR = '';

	// Magische Konstanten auch fr PHP-Includes

	// $TITLE = $TITLE;
	$SOFTWARE = my_version();
	$DOMAIN = ownDomainURI();
	$EML_DOMAIN = ownEMailDomainURI();
	$SYSTEM_URI = ownSystemURI();
	$SYSTEM_REL_URI = ownSystemRelURI();
	$CUR_DIR_URI = ownDirectoryURI($RELDIR);
	$RELDIR = remove_backslash($RELDIR);
	$CURYEAR = date('Y');
	if (file_exists($content_file)) {
		$LASTMOD = date(CFG_DATE_FORMAT, filemtime($content_file));
	} else {
		$LASTMOD = 'n/a';
	}

	// Errorpages

	$is_error_page = false;
	if (file_exists($content_file)) {
		$content = file_get_contents($content_file);
	} else {
		// Errordocument in der Wurzel ist Pflicht
		$content_file = determinateFile(NOTFOUND_NAME.CFG_EXTENSION);

		$wdir = dir_add_trailing_slash(dirname($reqfile));
		do {
			if (file_exists($wdir.NOTFOUND_NAME.CFG_EXTENSION)) {
				$content_file = determinateFile($wdir.NOTFOUND_NAME.CFG_EXTENSION);
				break;
			}

			$wdir = path_up($wdir);
			if ($wdir == '/') $wdir = '';
		} while ($wdir != '');

		// Das relative Verzeichnis ist der reale Ort der gefundenen
		// Fehlerseite, nicht das "Fantasieverzeichnis", das der
		// Benutzer angefordert hat und ggf. den Fehler verursacht hat.
		$directory = $wdir;

		unset($wdir);

		header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');

		if (!$content_file) {
			echo simple_html_head('MarxEngine Fatal Error');
			echo '<h1>Not Found</h1>';
			echo '<p>The requested page "'.$reqfile.'" as well as the error page "'.NOTFOUND_NAME.CFG_EXTENSION.'" were not found.</p>';
			echo simple_html_foot();
			die();
		} else {
			$content = file_get_contents($content_file);
			$is_error_page = true;
		}
	}

	// Search for interrupt meta tags and execute them

	// Content sichern, damit die magischen Wrter Design,
	// Metatags, Title und Menu erhalten bleiben, wenn $content gendert wird
	$original_content = $content;
	// Das Schlsselwort $LASTMOD$ wird mit $content_file berechnet.

	// Remove all comments from the output (except comments inside of JavaScript)
	// First time to avoid commented out metatags, titles etc.

	$content = remove_comments($content);

	// Init variables

	$interrupt_outputs_top = '';
	$interrupt_outputs_bottom = '';

	// Interrupts evaluieren

	$res_ary = findoutInterrupts($original_content, $RELDIR);

	if ((is_array($res_ary)) && (count($res_ary) > 0)) {
		foreach ($res_ary as $inter) {
			if ($inter == '*empty*') continue;

			$inter_file = determinateFile($inter.CFG_EXTENSION);

			if (!$inter_file) {
				header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error');
				echo simple_html_head('MarxEngine Fatal Error');
				echo '<h1>Internal Server Error</h1>';
				echo '<p>Interrupt file "'.$inter.CFG_EXTENSION.'" not found.</p>';
				echo simple_html_foot();
				die();
			} else {
				$inter_cont = file_get_contents($inter_file);
			}

			unset($inter_file);

			$interrupt_output_at_bottom = CFG_INTERRUPT_AT_BOTTOM_DEFAULT;
			$interrupt_do_continue = CFG_INTERRUPT_DO_CONTINUE;

			// Interrupt evaluieren

			ob_start();
			// Entscheidet, ob man weiterdarf oder nicht (die)
			eval('?>'.$inter_cont);
			$cur_ir_output = ob_get_contents();
			ob_end_clean();

			if ($interrupt_output_at_bottom) {
				$interrupt_outputs_bottom .= $cur_ir_output;
			} else {
				$interrupt_outputs_top = $cur_ir_output . $interrupt_outputs_top;
			}

			unset($interrupt_output_at_bottom);
			unset($cur_ir_output);
			unset($inter_cont);

			if (!$interrupt_do_continue) break;
		}

		unset($inter);
	}
	unset($res_ary);

	// Search for the design meta tag

	$design = findoutDesign($original_content, $RELDIR);

	// Search for the menu meta tag

	$menues = findoutMenues($original_content, $RELDIR);

	// Search for the metatags meta tag

	$metatags = findoutMetatags($original_content, $RELDIR);

	// Get the title

	$TITLE = findoutTitle($original_content);
	$TITLE = strip_tags($TITLE);

	// Da Microsoft Expression Web gerne Style-Sheets anlegt, mssen wir diesen Tag mitnehmen!
	// siehe PASS_CONTENT_STYLE_TAG_INTO_DESIGN

	if (PASS_CONTENT_STYLE_TAG_INTO_DESIGN) {
		preg_match_all('@<style([^>]*?)>(.+?)</style>@smi', $content, $treffer, PREG_SET_ORDER);

		$styles = '';

		foreach ($treffer as $val) {
			if (isset($val[0])) {
				$style = $val[0];
			} else {
				$style = '';
			}

			$styles .= $style;
		}
		unset($style);
		unset($treffer);
		unset($val);
	}

	// Cut out only the body -- AT THIS POINT, META-TAG PARSING IS NOT POSSIBLE ANYMORE! (if <meta> is in <head>)

	// Both ways are working
	// preg_match('@<body((?!>).)*>(.+?)</body>@smi', $content, $treffer);
	preg_match('@<body([^>]*?)>(.+?)</body>@smi', $content, $treffer);

	if (isset($treffer[2])) {
		$content = $treffer[2];
	} else {
		// header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error');
		// echo simple_html_head('MarxEngine Fatal Error');
		// echo '<h1>Internal Server Error</h1>';
		// echo '<p>Content document "'.$reqfile.'" has no parseable body.</p>';
		// echo simple_html_foot();
		// die();
	}

	unset($treffer);

	// Append the interrupt outputs at the end of the content

	$content = $interrupt_outputs_top.$content.$interrupt_outputs_bottom;

	unset($interrupt_outputs_top);
	unset($interrupt_outputs_bottom);

	// Load the design sheet

	$design_cont = getDesignContents($design);

	if ($design_cont === false) {
		header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error');
		echo simple_html_head('MarxEngine Fatal Error');
		echo '<h1>Internal Server Error</h1>';
		echo '<p>Cannot load design "'.$design.CFG_EXTENSION.'".</p>';
		echo simple_html_foot();
		die();
	}

	// Since the design sheet is relative to the directory (it was offline designed), we change the base now
	// Zu lsendes Problem
	// Head/Design braucht BASE A, Content braucht BASE B. Nur mglich mit JavaScript. Unmglich fr Bots.

	$design_url_base = '/'.$SYSTEM_REL_URI;
	if (dirname($design) != '.') {
		$design_url_base .= dirname($design).'/';
	}

	// Einmal vorweg wegen dem HREF-Change
	$design_cont = replace_magic_consts($design_cont, $RELDIR, $content_file, $TITLE);


	ob_start();
	eval('?>'.$design_cont);
	$design_cont = ob_get_contents();
	ob_end_clean();




	$design_cont = changeHrefBases($design_cont, $design_url_base);

	// Insert Content into design

	$content = str_replace('$CONTENT$', $content, $design_cont);

	unset($design_cont);
	unset($design_file);

	// Insert the specific styles

	if (PASS_CONTENT_STYLE_TAG_INTO_DESIGN) {
		$content = str_replace('</head>', $styles.'</head>', $content);
	}
	unset($styles);

	// Load and insert meta tags into design

	$meta_collection = '';

	if ((is_array($metatags)) && (count($metatags) > 0)) {
		foreach ($metatags as $meta) {
			if ($meta == '*empty*') continue;

			$metatag_file = determinateFile($meta.CFG_EXTENSION);

			if (!$metatag_file) {
				header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error');
				echo simple_html_head('MarxEngine Fatal Error');
				echo '<h1>Internal Server Error</h1>';
				echo '<p>Cannot load metatag file "'.$meta.CFG_EXTENSION.'".</p>';
				echo simple_html_foot();
				die();
			} else {
				$metatag_cont = file_get_contents($metatag_file);
			}

			$meta_collection .= $metatag_cont;

			unset($metatag_cont);
			unset($metatag_file);
		}
		unset($meta);
	}
	unset($metatags);

	if (CFG_PLACE_METATAGS_ON_TOP) {
		$content = str_replace('<head>', '<head>'.$meta_collection, $content);
	} else {
		$content = str_replace('</head>', $meta_collection.'</head>', $content);
	}
	unset($meta_collection);

	// Load and insert menu into design

	if ((is_array($menues)) && (count($menues) > 0)) {
		foreach ($menues as $menu_idx => $menu) {
			if ($menu == '*empty*') {
				$menu_file = '*empty*';
			} else {
				$menu_file = determinateFile($menu.CFG_EXTENSION);
			}

			if (!$menu_file) {
				header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error');
				echo simple_html_head('MarxEngine Fatal Error');
				echo '<h1>Internal Server Error</h1>';
				echo '<p>Cannot load menu "'.$menu.CFG_EXTENSION.'".</p>';
				echo simple_html_foot();
				die();
			} else {
				if ($menu_file == '*empty*') {
					$menu_cont = '';
				} else {
					$menu_cont = file_get_contents($menu_file);
				}
			}

			$menu_cont = replace_magic_consts($menu_cont, $RELDIR, $content_file, $TITLE);
			$content = str_replace('$MENU'.(($menu_idx == 0) ? '' : $menu_idx+1).'$', $menu_cont, $content);

			// Problem: Derzeit kann nicht gezhlt werden, wie viele Mens existieren
			// $content = str_replace('$MENU_XX$', $menu_cont.'$MENU_XX$', $content);

			unset($menu_cont);
			unset($menu_file);
		}
		unset($menu_idx);
		unset($menu);
	}
	unset($menues);
	// $content = str_replace('$MENU_XX$', '', $content);

	// Remove all comments from the output (except comments inside of JavaScript)
	// Second time to avoid replacing of magic consts

	$content = remove_comments($content);

	// Insert the title, misc infos, the modification time and the title into design

	$content = replace_magic_consts($content, $RELDIR, $content_file, $TITLE);

	// Every parsing of $magic-constants$ is finished. We can delete $original_content now.

	unset($original_content);

	// Remove all comments from the output (except comments inside of JavaScript)
	// Third time to remove comments inside included contents like metatags etc

	$content = remove_comments($content);

	// Evaluation and Output

	ob_start();
	eval('?>'.$content);
	$content = ob_get_contents();
	ob_end_clean();

	if ($is_error_page) $content .= IE_ERRORPAGE_FIX; // Wenn der Content zu kurz sein sollte

	// Magische Variablen entfernen

	unset($TITLE);
	unset($SOFTWARE);
	unset($DOMAIN);
	unset($EML_DOMAIN);
	unset($SYSTEM_URI);
	unset($SYSTEM_REL_URI);
	unset($CUR_DIR_URI);
	unset($RELDIR);
	unset($CURYEAR);
	unset($LASTMOD);

	// Call filters which can modify $content (e.g. to strip comments from the final output)

	$incl_ary = glob(dir_add_trailing_slash(FILTER_DIR).'*'.INC_PHP);
	if ((is_array($incl_ary)) && (count($incl_ary) > 0)) {
		foreach ($incl_ary as $val) {
			if (file_exists($val)) include $val;
		}
		unset($val);
	}
	unset($incl_ary);

	// Ausgabe des Contents

	echo $content;
	unset($content);

	unset($directory);
	unset($RELDIR);
}

/* FUNCTIONS

 #######
 #       #    # #    #  ####  ##### #  ####  #    #  ####
 #       #    # ##   # #    #   #   # #    # ##   # #
 #####   #    # # #  # #        #   # #    # # #  #  ####
 #       #    # #  # # #        #   # #    # #  # #      #
 #       #    # #   ## #    #   #   # #    # #   ## #    #
 #        ####  #    #  ####    #   #  ####  #    #  ####

*/

function determinateFile($filename) {
	if (file_exists($filename)) {
		return $filename;
	} else {
		return false;
	}
}

function getMetaTag($name, $content) {
	$content = remove_comments($content); // Keine auskommentierten Meta-Tags erlauben

	preg_match('@<meta *name="'.$name.'" *content="(.*)"@i', $content, $treffer);

	if (isset($treffer[1])) {
		return $treffer[1];
	} else {
		preg_match('@<meta *content="(.+?)" *name="'.$name.'"@i', $content, $treffer);

		if (isset($treffer[1])) {
			return $treffer[1];
		} else {
			return false;
		}
	}

	unset($treffer);
}

function remove_comments($text) {
	if (!function_exists('do_replace_comments')) {
		function do_replace_comments($treffer) {
			$pos = strpos($treffer[0], '// -->');
			if ($pos === false) {
				return '';
			} else {
				return $treffer[0]; // Es handelt sich scheinbar um ein JavaScript
			}
		}
	}
	return preg_replace_callback('@<!--(.+?)-->@sm', 'do_replace_comments', $text);
}

// http://www.viathinksoft.de/?page=codelib&showid=41
// Modified
function getAllFiles($directory, $recursive = true, $extension = false) {
	$result = array();
	$handle = opendir($directory);
	while ($datei = readdir($handle))
	{
		if (($datei != '.') && ($datei != '..'))
		{
			$file = $directory.$datei;
			if (is_dir($file)) {
				if ($recursive) {
					$result = array_merge($result, getAllFiles(dir_add_trailing_slash($file), $recursive, $extension));
				}
			} else {
				if ($extension) {
					$ext = substr($file, strrpos($file, '.') /* +1 */);
					if ($ext == $extension) {
						$result[] = $file;
					}
				} else {
					$result[] = $file;
				}
			}
		}
	}
	closedir($handle);
	return $result;
}

function getAllHtmlFiles($directory, $recursive = true) {
	return getAllFiles($directory, $recursive, CFG_EXTENSION);
}

function getAllFilesAndDirsNonRec($directory) {
	$result = array();
	$handle = opendir($directory);
	while ($datei = readdir($handle))
	{
		if ($datei != '.')
		{
			$file = $directory.$datei;
			if (is_dir($file)) $file .= '/';
			$result[] = $file;
		}
	}
	closedir($handle);
	return $result;
}

function findoutDesign($content, $dir) {
	$design = getMetaTag('design', $content);
	if ($design) $design = replace_magic_consts($design, $dir, false, findoutTitle($content));
	if ($dir != '') $dir = dir_add_trailing_slash($dir);

	if ($design) {
		if ($design == '*empty*') {
			$result = '*empty*'; // Das Design wird spter generiert
		} else {
			$result = $design;
			if (($dir != '') && ($dir != '.')) add_prefix($result, 0, $dir);
			add_filename_prefix($result, 0, DESIGN_PREFIX);
			remove_thisdir_prefix($result, 0);
		}
	} else {
		$design = DEFAULT_NAME;
		add_filename_prefix($design, 0, DESIGN_PREFIX);
		remove_thisdir_prefix($design, 0);

		if (file_exists($dir.$design.CFG_EXTENSION)) {
			$result = $dir.$design;
		} else {
			// Es wird ein leeres Designsheet spter generiert
			$result = '';

			while ($dir != '') {
				$dir = path_up($dir);
				if ($dir == '/') $dir = '';

				if (file_exists($dir.$design.CFG_EXTENSION)) {
					$result = $dir.$design;
					break;
				}
			}
		}
	}

	trim_value($result);
	simplify_dir($result);

	return $result;
}

function getDesignContents($design) {
	global $TITLE;

	if (($design != '') && ($design != '*empty*')) {
		// Load from existing file
		$design_file = determinateFile($design.CFG_EXTENSION);

		if (!$design_file) {
			// Dieser Fehler sollte im normalen Betrieb nicht mehr mglich sein,

			// da bei aktiver Angabe file_exists() durchgefhrt wird
			// und bei vergeblicher aufsteigender Suche das Resultat '' ist.

			return false;
		} else {
			return file_get_contents($design_file);
		}
	} else {
		// Generate an empty design
		$design_cont = '';
		$design_cont .= simple_html_head($TITLE);
		$design_cont .= '$CONTENT$';
		$design_cont .= simple_html_foot();
		return $design_cont;
	}
}

function findoutMenues($content, $dir) {
	$menues = getMetaTag('menues', $content);
	if ($menues) $menues = replace_magic_consts($menues, $dir, false, findoutTitle($content));
	if ($dir != '') $dir = dir_add_trailing_slash($dir);

	$design = findoutDesign($content, $dir);
	$design_cont = getDesignContents($design);
	if ($design_cont === false) $design_cont = '';

	if ($menues) {
		$result = explode(';', $menues);
		if (($dir != '') && ($dir != '.')) array_walk($result, 'add_prefix', $dir);
		array_walk($result, 'add_filename_prefix', MENU_PREFIX);
		array_walk($result, 'remove_thisdir_prefix');
	} else {
		$result = array();

		// Find also default handlers for 2nd, 3rd... menues
		$cnt = 0;
		while (true) {
			$cnt++;

			$num = ($cnt == 1) ? '' : $cnt;
			if (strpos($design_cont, '$MENU'.$num.'$') === false) break;
			$found = '*empty*';

			if (file_exists($dir.MENU_PREFIX.DEFAULT_NAME.$num.CFG_EXTENSION)) {
				$found = $dir.MENU_PREFIX.DEFAULT_NAME.$num;
			} else {
				$wdir = $dir;
				while ($wdir != '') {
					$wdir = path_up($wdir);
					if ($wdir == '/') $wdir = '';

					if (file_exists($wdir.MENU_PREFIX.DEFAULT_NAME.$num.CFG_EXTENSION)) {
						$found = $wdir.MENU_PREFIX.DEFAULT_NAME.$num;
						break;
					}
				}
				unset($wdir);
			}

			$result[] = $found;
		}
	}

	array_walk($result, 'trim_value');
	array_walk($result, 'simplify_dir');

	return $result;
}

function findoutMetatags($content, $dir) {
	$metatags = getMetaTag('metatags', $content);
	if ($metatags) $metatags = replace_magic_consts($metatags, $dir, false, findoutTitle($content));
	if ($dir != '') $dir = dir_add_trailing_slash($dir);

	if ($metatags) {
		$result = explode(';', $metatags);
		if (($dir != '') && ($dir != '.')) array_walk($result, 'add_prefix', $dir);
		array_walk($result, 'add_filename_prefix', METATAGS_PREFIX);
		array_walk($result, 'remove_thisdir_prefix');
	} else {
		if (file_exists($dir.METATAGS_PREFIX.DEFAULT_NAME.CFG_EXTENSION)) {
			$result = array($dir.METATAGS_PREFIX.DEFAULT_NAME);
		} else {
			$result = array();

			while ($dir != '') {
				$dir = path_up($dir);
				if ($dir == '/') $dir = '';

				if (file_exists($dir.METATAGS_PREFIX.DEFAULT_NAME.CFG_EXTENSION)) {
					$result = array($dir.METATAGS_PREFIX.DEFAULT_NAME);
					break;
				}
			}
		}
	}

	array_walk($result, 'trim_value');
	array_walk($result, 'simplify_dir');

	return $result;
}

function findoutInterrupts($content, $dir) {
	$interrupts = getMetaTag('interrupts', $content);
	if ($interrupts) $interrupts = replace_magic_consts($interrupts, $dir, false, findoutTitle($content));
	if ($dir != '') $dir = dir_add_trailing_slash($dir);

	if ($interrupts) {
		$result = explode(';', $interrupts);
		if (($dir != '') && ($dir != '.')) array_walk($result, 'add_prefix', $dir);
		array_walk($result, 'add_filename_prefix', INTERRUPT_PREFIX);
		array_walk($result, 'remove_thisdir_prefix');
	} else {
		if (file_exists($dir.INTERRUPT_PREFIX.DEFAULT_NAME.CFG_EXTENSION)) {
			$result = array($dir.INTERRUPT_PREFIX.DEFAULT_NAME);
		} else {
			$result = array();

			while ($dir != '') {
				$dir = path_up($dir);
				if ($dir == '/') $dir = '';

				if (file_exists($dir.INTERRUPT_PREFIX.DEFAULT_NAME.CFG_EXTENSION)) {
					$result = array($dir.INTERRUPT_PREFIX.DEFAULT_NAME);
					break;
				}
			}
		}
	}

	array_walk($result, 'trim_value');
	array_walk($result, 'simplify_dir');

	return $result;
}

function findoutTitle_TitleTag($content) {
	preg_match('@<title>(.+?)</title>@ism', $content, $treffer);

	if (isset($treffer[1])) {

		return $treffer[1];
	} else {
		return false;
	}
}

function findoutTitle_FirstH1($content) {
	preg_match('@<h1([^>]*?)>(.+?)</h1>@ism', $content, $treffer);

	if (isset($treffer[2])) {
		return $treffer[2];
	} else {
		return false;
	}
}

function findoutTitle($content) {
	if (CFG_TITLE_ORDER_H1_BEFORE_TITLE) {
		$res = findoutTitle_FirstH1($content);
		if ($res) return $res;
		$res = findoutTitle_TitleTag($content);
		if ($res) return $res;
	} else {
		$res = findoutTitle_TitleTag($content);
		if ($res) return $res;
		$res = findoutTitle_FirstH1($content);
		if ($res) return $res;
	}

	return LNG_UNKNOWN_TITLE;
}

function ownDomainURI() {
	if ((array_key_exists("HTTPS", $_SERVER)) && ($_SERVER['HTTPS'] == 'on')) {
		$protokoll = 'https';
	} else {
		$protokoll = 'http';
	}

	return $protokoll.'://'.$_SERVER['HTTP_HOST'].'/';
}

function ownEMailDomainURI() {
	return remove_beginning_i($_SERVER['HTTP_HOST'], 'www.');
}

function ownSystemURI() {
	return ownDomainURI().ownSystemRelURI();
}

function ownSystemRelURI() {
	$uri = $_SERVER['SCRIPT_NAME'];
	$uri = remove_beginning($uri, '/');
	if (substr($uri, strlen($uri)-1, 1) != '/') {
		$uri = dirname($uri);
	}
	$uri = dir_add_trailing_slash($uri);
	if ($uri == './') $uri = '';
	return $uri;
}

function ownDirectoryURI($RELDIR) {
	// Anmerkung: Errorpages berschreiben das RELDIR
	// Daher wird der Wert zusammengesetzt
	return ownSystemURI().$RELDIR;
}

function dir_add_trailing_slash($directory) {
	if (substr($directory, strlen($directory)-1, 1) != '/') $directory .= '/';
	return $directory;
}

function remove_backslash($directory) {
	if (substr($directory, strlen($directory)-1, 1) == '/') {
		$directory = substr($directory, 0, strlen($directory));
	}
	return $directory;
}

function trim_value(&$value) {
	$value = trim($value);
}

function add_prefix(&$value, $key, $prefix) {
	if ($value == '*empty*') return;
	$value = $prefix.$value;
}

function add_filename_prefix(&$value, $key, $prefix) {
	if ($value == '*empty*') return;
	$value = dir_add_trailing_slash(dirname($value)).$prefix.basename($value);
}

function my_version() {
	return 'MarxEngine Version '.MARX_ENGINE_VER;
}

function remove_beginning($content, $beginning) {
	if (beginsWith($content, $beginning)) {
		return substr($content, strlen($beginning), strlen($content)-strlen($beginning));
	} else {
		return $content;
	}
}

function remove_beginning_i($content, $beginning) {
	if (beginsWithI($content, $beginning)) {
		return substr($content, strlen($beginning), strlen($content)-strlen($beginning));
	} else {
		return $content;
	}
}

function simplify_dir(&$value) {
	// Verhindert, dass z.B. ein Interrupt "../xyz" mglich ist, wenn
	// unser aktuelles Verzeichnis keine Interrupts besitzt.
	// "../" muss eliminiert werden.

	$value = preg_replace('@(/|^)(.+?)/\.\./@', '$1', $value);
}

function beginsWith($content, $beginning) {
	// return substr($content, 0, strlen($beginning)) == $beginning;
	return (strncmp($content, $beginning, strlen($beginning)) == 0);
}

function beginsWithI($content, $beginning) {
	return beginsWith(strtolower($content), strtolower($beginning));
}

function endsWith( $str, $sub ) {
	return ( substr( $str, strlen( $str ) - strlen( $sub ) ) == $sub );
}

function endsWithI($content, $beginning) {
	return endsWith(strtolower($content), strtolower($beginning));
}

function path_up($dir) {
	$dir = dir_add_trailing_slash($dir);
	// http://www.php.net/manual/en/function.strrpos.php#51636
	return substr($dir, 0, @strrpos($dir, '/', -2 )).'/';
}

function build_seg($c) {
	$c = $c[1];

	$res = '/$SYSTEM_REL_URI$';
	for ($i=1; $i<=$c; $i++) {
		$res .= '$SUB'.$i.'$';
	}

	return $res;
}

function replace_magic_consts($content, $RELDIR, $content_file, $TITLE) {
	if ($TITLE !== false) {
		$content = str_replace('$TITLE$', $TITLE, $content);
	}

	// $SEG[zahl 0..n]$ := /$SYSTEM_REL_URI$$SUB1$..$SUBn$
	$content = preg_replace_callback('@\$SEG([0-9]*)\$@', 'build_seg', $content);

	// $SUB[zahl 1..n]$ entspricht einem Segment der URL (z.B. fr Men's) inklusive '/'.
	// URL a/b/c/ has $SUB2$=b/
	$ary = explode('/', $RELDIR);
	foreach ($ary as $n => $val) {
		if ($val != '') {
			$content = str_replace('$SUB'.($n+1).'$', dir_add_trailing_slash($val), $content);
		}
	}
	unset($n);
	unset($val);
	unset($ary);

	// Remove not used SUBs
	$content = preg_replace('@\$SUB([0-9]*)\$@', '', $content);

	$content = str_replace('$SOFTWARE$', my_version(), $content);
	$content = str_replace('$DOMAIN$', ownDomainURI(), $content);
	$content = str_replace('$EML_DOMAIN$', ownEMailDomainURI(), $content);
	$content = str_replace('$SYSTEM_URI$', ownSystemURI(), $content);
	$content = str_replace('$SYSTEM_REL_URI$', ownSystemRelURI(), $content);
	if ($RELDIR !== false) {
		$content = str_replace('$CUR_DIR_URI$', ownDirectoryURI($RELDIR), $content);
		$RELDIR = remove_backslash($RELDIR);
		$content = str_replace('$RELDIR$', $RELDIR, $content);
	}
	$content = str_replace('$CURYEAR$', date('Y'), $content);

	if ($content_file !== false) {
		$lastmod = date(CFG_DATE_FORMAT, filemtime($content_file));
		$content = str_replace('$LASTMOD$', $lastmod, $content);
	}

	return $content;
}

function simple_html_head($title) {
	return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
       "http://www.w3.org/TR/html4/loose.dtd">

<html>

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title>'.$title.'</title>
</head>

<body>';

}

function simple_html_foot() {
	return IE_ERRORPAGE_FIX.'

</body>

</html>';

}

function is_allowed_file($filename) {
	global $disallow_dirs;

	$filename = urldecode($filename);

	if (beginsWith($filename, AUTO_INCLUDE_DIR)) return false;
	if (beginsWith($filename, FILTER_DIR)) return false;

	foreach ($disallow_dirs as $val) {
		if (beginsWith($filename, $val)) return false;
	}

	$filename = basename($filename);

	if (beginsWith($filename, DESIGN_PREFIX)) return false;
	if (beginsWith($filename, METATAGS_PREFIX)) return false;
	if (beginsWith($filename, INTERRUPT_PREFIX)) return false;
	if (beginsWith($filename, MENU_PREFIX)) return false;

	if (preg_match('|google[a-f0-9]{16}.html|', $filename)) return false;

	return true;
}

function is_no_errorpage($filename) {
	$filename = urldecode($filename);
	$filename = basename($filename);

	if ($filename == NOTFOUND_NAME.CFG_EXTENSION) return false;

	return true;
}

function remove_thisdir_prefix(&$value) {
	$value = remove_beginning($value, './');
}

function ob_kill_all() {
	while (ob_get_level() > 0) {
		ob_end_clean();
	}
}

function redirect($file) {
	header('location: '.$file);

	$file = urlencode($file);

	ob_kill_all();

	ob_start();
	echo simple_html_head('Redirection');
	echo '<h1>Redirection</h1>';
	echo 'Please click <a href="'.$file.'">here</a> to get redirected.';
	echo simple_html_foot();
	$result = ob_get_contents();
	ob_end_clean();

	$result = str_replace('</head>', '<meta http-equiv="Refresh" content="0; url='.$file.'"></head>', $result);

	die($result);
}

class UrlParseIterator {
	var $use_original_bracket_at_link = false;
	var $use_original_bracket_at_css = false;
	var $use_original_bracket_at_other = false;

	protected function process_url($url) {
		// Overwrite this method in a derivate!
		return $url;
	}

	// LINK

	private function link_style_regex() {
		return "/(<a\s[^>]*(href)\s*=\s*)(?(?=[\"'])(([\"'])([^>]*)\\4)|()([^ >]*?))([^>]*>)(.*)<\/a>/isUm";
	}

	protected function link_callback($complete, $pre, $post, $urltype, $bracket, $url, $linktext) {
		$url = $this->process_url($url);

		return $pre.$bracket.$url.$bracket.$post.$linktext.'</a>';
	}

	private function link_first_callback($c) {
		$complete = $c[0];

		$pre = $c[1];
		$post = $c[8];

		$urltype = $c[2]; // = href

		if ($this->use_original_bracket_at_link) {
			$bracket = $c[4];
		} else {
			$bracket = '"';
		}

		$url = $c[5].$c[7]; // Either [5] OR [7] is filled, so I simply concat them.

		$linktext = $c[9];

		return $this->link_callback($complete, $pre, $post, $urltype, $bracket, $url, $linktext);
	}

	// CSS

	private function css_style_regex() {
		return "/url\(\s*(?(?=[\"'])(([\"'])([^>]*)\\2)|([^\)]*?))\)/isUm";
	}

	protected function css_callback($complete, $bracket, $url) {
		$url = $this->process_url($url);

		return 'url('.$bracket.$url.$bracket.')';
	}

	private function css_first_callback($c) {
		$complete = $c[0];

		if ($this->use_original_bracket_at_css) {
			$bracket = $c[2];
		} else {
			$bracket = "'";
		}

		if (!isset($c[4])) $c[4] = '';
		$url = $c[3].$c[4]; // Either [3] OR [4] is filled, so I simply concat them.

		return $this->css_callback($complete, $bracket, $url);
	}

	// Other (does not include a-href, but base-href etc.)

	private function other_style_regex() {
		return "/((<(?!a\s)[^><]*)(href)|src|background|code)\s*=\s*(?(?=[\"'])(([\"'])([^>]*)\\5)|([^ >]*?))/isUm";
	}

	protected function other_callback($complete, $bracket, $type, $url) {
		$url = $this->process_url($url);

		return $type.'='.$bracket.$url.$bracket;
	}

	private function other_first_callback($c) {
		// Aufgrund des regex ist bei einem href $c[0] nicht href="..." sondern <base ... href="..."
		// Wir verdecken diesen zustzlichen Anfang, leiten ihn an die abstrakte callback-Funktion weiter
		// und fgen spter beim zurckliefern diesen Prfix $pre wieder hinzu.
		$pre = $c[2];

		$complete = remove_beginning($c[0], $pre);

		if ($c[3] == '') {
			$type = $c[1];
		} else {
			$type = $c[3];
		}

		if ($this->use_original_bracket_at_other) {
			$bracket = $c[5];
		} else {
			$bracket = '"';
		}

		if (!isset($c[7])) $c[7] = '';
		$url = $c[6].$c[7]; // Either [6] OR [7] is filled, so I simply concat them.

		return $pre.$this->other_callback($complete, $bracket, $type, $url);
	}

	// Processing functions

	private function process_links($content) {
		return preg_replace_callback($this->link_style_regex(), array(&$this, 'link_first_callback'), $content);
	}

	private function process_other($content) {
		return preg_replace_callback($this->other_style_regex(), array(&$this, 'other_first_callback'), $content);
	}

	private function process_css($content) {
		return preg_replace_callback($this->css_style_regex(), array(&$this, 'css_first_callback'), $content);
	}

	public function process($content) {
		$content = $this->process_links($content);
		$content = $this->process_other($content);
		$content = $this->process_css($content);

		return $content;
	}
}

class BaseChanger extends UrlParseIterator {
	var $newBase;

	protected function process_url($url) {
		if (beginsWith($url, '/')) return $url;

		if (beginsWithI($url, 'http://')) return $url;
		if (beginsWithI($url, 'https://')) return $url;
		if (beginsWithI($url, 'ftp://')) return $url;
		if (beginsWithI($url, 'file:///')) return $url;
		if (beginsWithI($url, 'gopher://')) return $url;

		return $this->newBase.$url;
	}
}

function changeHrefBases($content, $newbase) {
	$newbase = dir_add_trailing_slash($newbase);

	$t = new BaseChanger;
	$t->newBase = $newbase;
	return $t->process($content);
}

?>
